<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref } from 'vue';
//@ts-ignore
import VuePlyr from '@skjnldsv/vue-plyr';
import '@skjnldsv/vue-plyr/dist/vue-plyr.css'
import { onMounted } from 'vue';

const props = defineProps<{
    src: string,
    type: string
}>();

const canvasRef = ref();
let audioCtx: any;
let canvasCtx: any;
const currentTime = ref(0);

const isPaused = ref(true);
const showAudioPlayer = ref(false);

const handleActivateAudio = async ()=>{
    showAudioPlayer.value = true;
    if (!audioCtx) {
            audioCtx = new AudioContext();
    }
    await visualize();
    if (audioRef.value && audioRef.value.player) {
        audioRef.value!.player.on('timeupdate', () => {
            currentTime.value = audioRef.value!.player.currentTime;
        })
        audioRef.value!.player.on('pause', () => {
            isPaused.value = true;
        })
        audioRef.value!.player.on('play', () => {
            isPaused.value = false;
        })
    }
};

const loadAudioFile = async () => {
    const response = await fetch(props.src);
    const audioData = await response.arrayBuffer();
    return audioCtx.decodeAudioData(audioData);
};

const visualize = async () => {
    const audioBuffer = await loadAudioFile();
    let source: any = null;
    let startTime = 0;

    if (!canvasCtx) {
        canvasCtx = canvasRef.value.getContext("2d");
    }

    const analyser = audioCtx.createAnalyser();
    analyser.fftSize = 1024;
    let oldHeight: any;
    let targetHeight: any;
    drawBars();


    const playAudio = (currentTime: number) => {
        source = audioCtx.createBufferSource();
        source.buffer = audioBuffer;
        source.connect(analyser);
        source.start(0, currentTime);
        startTime = audioCtx.currentTime - currentTime;

    };

    const stopAudio = () => {
        if (source !== null) {
            source.stop();
            source.disconnect();
            source = null;

        }
    };

    function drawBars() {
        requestAnimationFrame(drawBars);
        const bufferLength = analyser.frequencyBinCount;
        if (!oldHeight || oldHeight.length !== bufferLength) {
            oldHeight = new Uint8Array(bufferLength);
            targetHeight = new Uint8Array(bufferLength);
        }
        if (isPaused.value) {
            drawCanvas(getPauseValue)
            return;
        }
        if (currentTime.value !== startTime) {
            stopAudio();
            playAudio(currentTime.value);
        }

        const dataArray = new Uint8Array(bufferLength);
        analyser.getByteFrequencyData(dataArray);

        function drawCanvas(drawValue: any) {
            let canvas = canvasRef.value;
            if (canvas) {
                const WIDTH = canvas.width
                const HEIGHT = canvas.height;

                canvasCtx.fillStyle = '#ffffff';
                canvasCtx.fillRect(0, 0, WIDTH, HEIGHT);

                const barWidth = (WIDTH / bufferLength) * 3;
                let barHeight;
                let x = 0;

                for (let i = 0; i < bufferLength; i++) {
                    barHeight = drawValue(i);
                    oldHeight[i] = barHeight;
                    canvasCtx.fillStyle = "#cccccc";
                    canvasCtx.fillRect(x, HEIGHT - barHeight / 2, barWidth, barHeight / 2);
                    x += barWidth + 1;
                }
            }
        }
        function getPauseValue(i: number) {
            return Math.max(oldHeight[i] - 10, 0);
        }

        function getPlayValue(i: number) {
            targetHeight[i] = dataArray[i];
            return Math.min(oldHeight[i] + 10, targetHeight[i])
        }

        drawCanvas(getPlayValue)
    }
}

const audioRef = ref<any>(null);


</script>
<template>
    <div class="pt-2">
        <VuePlyr v-if="type === 'video'"
            :options="{ controls: ['play-large', 'play', 'progress', 'current-time', 'mute', 'volume', 'fullscreen'] }">
            <video class="w-full min-h-10" preload="none" v-if="type === 'video'" controls playsinline>
                <source :src="src" />
                <span> {{ $t('contentPage.media.error') }}</span>
            </video>
        </VuePlyr>
        <div v-else-if="type === 'audio'">
            <div v-if="showAudioPlayer">
                <canvas class="h-14 w-full" ref="canvasRef"></canvas>
                <VuePlyr ref="audioRef" :options="{ controls: ['play', 'progress', 'current-time', 'mute', 'volume'] }">
                    <audio controls playsinline preload="none" class="w-full min-h-20">
                        <source :src="src" />
                        <span> {{ $t('contentPage.media.error') }}</span>
                    </audio>
                </VuePlyr>
            </div>
            <div class="h-24 w-full bg-white text-center" v-else>
                <button @click="handleActivateAudio"><i class="ri-play-line text-center text-8xl"></i></button>
            </div>
        </div>
    </div>
</template>

<style>
:root {
    --plyr-control-icon-size: 10px;
}

.plyr__volume {
    max-width: 33px;
    min-width: 0;
}

.plyr__volume input[data-plyr="volume"] {
    display: none;
    width: 77px;
    position: absolute;
    transform: rotate(270deg);
    top: -32px;
    left: -33px;
    height: 25px;
    padding-left: 18px;
}

.plyr__volume:hover input[data-plyr="volume"],
.plyr__volume input[data-plyr="volume"]:hover {
    display: block !important;
}

.plyr__controls {
    padding-top: 10px !important;
}

.plyr {
    min-width: 150px !important;
}
</style>